VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsSetupFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This is used for creating a Setup.Lst formatted file
'with all files in a directory.  There must be matching
'files in that directory (ie. Each compressed file must
'have its uncompressed partner in that same directory
'with the same file name - extension will be different).
'
'Thanks goes out to Randy Birch for the code used to
'retrieve the Date from a file.  The code for this can
'be found at:  http://www.mvps.org/vbnet/

Option Explicit

Public LastCharacter As String
Public InitialDirectory As String
Public CharactersToSkip As Integer
Public InstallPath As String

Private CompressedFileName As String
Private RegularFileName As String
Private FileSize As Long
Private DateModified As String

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Const OFS_MAXPATHNAME = 260
Private Const OF_READWRITE = &H2

Private Type OFSTRUCT
   cBytes      As Byte
   fFixedDisk  As Byte
   nErrCode    As Integer
   Reserved1   As Integer
   Reserved2   As Integer
   szPathName(OFS_MAXPATHNAME) As Byte
End Type

Private Type SYSTEMTIME
    wYear          As Integer
    wMonth         As Integer
    wDayOfWeek     As Integer
    wDay           As Integer
    wHour          As Integer
    wMinute        As Integer
    wSecond        As Integer
    wMilliseconds  As Long
End Type

Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Private Function GetFileDateString(CT As FILETIME) As String
  
    Dim ST As SYSTEMTIME
    Dim r As Long
    Dim ds As Single

'convert the passed FILETIME to a
'valid SYSTEMTIME format for display
    If FileTimeToSystemTime(CT, ST) Then
        ds = DateSerial(ST.wYear, ST.wMonth, ST.wDay)
        GetFileDateString = Format$(ds, "MM/DD/YY") & " 12:00:00"
    Else: GetFileDateString = ""
    End If
  
End Function

Private Sub GetFileInfo()

    Dim hFile As Long
    Dim fName As String
    Dim lSize As Long
    
'structures required
    Dim OFS As OFSTRUCT
    Dim FT_CREATE As FILETIME
    Dim FT_ACCESS As FILETIME
    Dim FT_WRITE As FILETIME
   
'open the file
    fName = InitialDirectory & "\" & RegularFileName
    hFile = OpenFile(fName, OFS, OF_READWRITE)

'get the FILETIME info for the created,
'accessed and last write info
    Call GetFileTime(hFile, FT_CREATE, FT_ACCESS, FT_WRITE)
    DateModified = GetFileDateString(FT_WRITE)
    FileSize = GetFileSize(hFile, 0)

'clean up by closing the file
    Call CloseHandle(hFile)
    
End Sub

Public Sub WriteFile()

    Dim iFreeFile As Integer
    Dim strFilePath As String
    Dim iFileCount As Long
    
    iFileCount = 1
    iFreeFile = FreeFile
    strFilePath = InitialDirectory & "\Setup.lst"
    
    Open strFilePath For Append As #iFreeFile
    
    CompressedFileName = Dir(InitialDirectory & "\*.??_")
    Do While CompressedFileName <> ""
        RegularFileName = Mid(CompressedFileName, 1 + CharactersToSkip, Len(CompressedFileName) - (1 + CharactersToSkip)) & LastCharacter
        GetFileInfo
        Print #iFreeFile, "File" & iFileCount & "=1,," & CompressedFileName & _
            "," & RegularFileName & "," & InstallPath & ",,," & DateModified & _
            "," & FileSize & ",,"""","""","""""
        CompressedFileName = Dir
        iFileCount = iFileCount + 1
    Loop
    
    Close #iFreeFile
    
End Sub
